#!/usr/bin/python

# Copyright (c) 1999-2002 Red Hat, Inc.  Distributed under GPL.
#
# Author: Adrian Likins <alikins@redhat.com>
#

import sys
sys.path.append("/usr/share/rhn")
from up2date_client import up2date
from up2date_client import config

cfg = config.initUp2dateConfig()

__rhnexport__ = [
    'update',
    'get']

argVerbose = 0

def update(configdict):
    """Invoke this to change the ondisk configuration of up2date"""
    if argVerbose > 1:
        print "called update_up2date_config"

    if type(configdict) != type({}):
        return (13, "Invalid arguments passed to function", {})

    unknownparams = []
    for param in configdict.keys():
        cfg.writeEntry(param,configdict[param])


    cfg.save()

    return (0, "config updated", {})

def get():
    """Reterieve the current configuration of up2date"""
    if argVerbose > 1:
        print "called get_up2date_config"

    ret = cfg.readValues()

    if type(ret) == type({}):
        return (0, "configuration retrived", {'data':ret})


def main():
    configdatatup = get()
    configdata = configdatatup[2]['data']
    print configdata

    import time
    timestamp = time.time()

    configdata['timeStampTest'] = timestamp
    print
    print configdata
    print
    print update(configdata)

    configdata= get()
    print configdata

if __name__ == "__main__":
    main()
