#!/usr/bin/python

# all the crap that is stored on the rhn side of stuff
# updating/fetching package lists, channels, etc

import up2dateAuth
import up2dateLog
import up2dateErrors
import config
import rpcServer

from translate import _

# so we can use the same code with python 1.5.2 and 2.2
try:
    from rhn import rpclib
except ImportError:
    rpclib = __import__("xmlrpclib")
                    
# grab an instance of the config class shared
cfg = config.initUp2dateConfig()
# get a reference to the log file object
log = up2dateLog.initLog()

global channel_blacklist
channel_blacklist = []

# for the gui client that needs to show more info
def getChannelDetails():

    s = rpcServer.getServer()
    channels = rpcServer.doCall(
        s.up2date.listChannels, up2dateAuth.getSystemId())

    return channels


global selected_channels
selected_channels = None
def getChannels():
    global selected_channels
    if not selected_channels:
       selected_channels = up2dateAuth.loginInfo.get('X-RHN-Auth-Channels')
    # doesnt do much at the moment, but I've got the feeling
    # it's going to get much more complicated
    return selected_channels


def updateChannels(tempchannels):
    global selected_channels
    selected_channels = []
    availableChannels = up2dateAuth.loginInfo.get('X-RHN-Auth-Channels')
    for channel in availableChannels:
       if channel[0] in tempchannels:
           selected_channels.append(channel)

    return selected_channels



def subscribeChannels(channels,username,passwd):
    s = rpcServer.getServer()
    try:
        channels = rpcServer.doCall(s.up2date.subscribeChannels,
                          up2dateAuth.getSystemId(),
                          channels,
                          username,
                          passwd)
    except rpclib.Fault, f:
        if f.faultCode == -36:
            raise up2dateErrors.PasswordError(f.faultString)
        else:
            raise up2dateErrors.CommunicationError(f.faultString)

def unsubscribeChannels(channels,username,passwd):
    s = rpcServer.getServer()
    try:
        channels = rpcServer.doCall(s.up2date.unsubscribeChannels,
                          up2dateAuth.getSystemId(),
                          channels,
                          username,
                          passwd)
    except rpclib.Fault, f:
        if f.faultCode == -36:
            raise up2dateErrors.PasswordError(f.faultString)
        else:
            raise up2dateErrors.CommunicationError(f.faultString)
