#!/usr/bin/python
#
# $Id: rhnErrata.py,v 1.1.2.1 2002/09/04 18:10:06 gafton Exp $

import os   
import sys  
import rpm
from translate import _, N_, cat
import up2dateErrors
import up2dateMessages
import rpmUtils
import up2dateAuth
import up2dateLog
import up2dateUtils
import rpcServer
import config

try:
    from rhn import rpclib
except ImportError:
    rpclib = __import__("xmlrpclib")

cfg = config.initUp2dateConfig()
log = up2dateLog.initLog()

def getAdvisoryInfo(pkg):
    from wrapperUtils import warningCallback
    
    s = rpcServer.getServer()

    db = rpmUtils.openrpmdb()
    try:
        indices = db.findbyname(pkg[0])
    except:
        indices = []

    h = None
    for i in indices:
        h = db[i]

    if h == None:
        return None
    
    try:
        pkgName = "%s-%s-%s" % (h['name'],
                                h['version'],
                                h['release'])
        log.log_me("getAdvisoryInfo for %s" % pkgName)
        info = rpcServer.doCall(s.errata.getPackageErratum,
                      up2dateAuth.getSystemId(),
                      pkg)
    except rpclib.Fault, f:
        if warningCallback:
            warningCallback(f.faultString)
        return None
    
    if info:
        return info
    
    try:
        log.log_me("getAdvisoryInfo for %s-0-0" % h['name'])
        info = rpcServer.doCall(s.errata.GetByPackage,
                      "%s-0-0" % h['name'],
                      up2dateUtils.getVersion())
    except rpclib.Fault, f:
        if warningCallback:
            warningCallback(f.faultString)
        return None
    
    return info
