#!/usr/bin/python

# all the crap that is stored on the rhn side of stuff
# updating/fetching package lists, channels, etc

import up2dateAuth
import up2dateLog
import up2dateUtils
import up2dateErrors
import xmlrpclib
import config
import rpcServer
import rpmSource
import rpmUtils
import rhnChannel
import rpmUtils
# so we can use the same code with python 1.5.2 and 2.2
try:
    from rhn import rpclib
except ImportError:
    rpclib = __import__("xmlrpclib")

from translate import _, N_, cat
# get a reference to the log file object
log = up2dateLog.initLog()

#grab an instance of the config class shared
cfg = config.initUp2dateConfig()


def remoteAddPackages(pkg):
    log.log_me("Adding packages to package profile: %s" % up2dateUtils.pprint_pkglist(pkg))
    s = rpcServer.getServer()
    try:
        if type(pkg[0]) == type([]):
            #s.set_transport(2, 2)
            rpcServer.doCall(s.registration.add_packages,up2dateAuth.getSystemId(), pkg)
        else:
            rpcServer.doCall(s.registration.add_packages,up2dateAuth.getSystemId(), [pkg])            
    except rpclib.Fault, f:
        raise up2dateErrors.CommunicationError(f.faultString)

def remoteDelPackages(pkg):
    log.log_me("Removing packages from package profile: %s" % up2dateUtils.pprint_pkglist(pkg))
    s = rpcServer.getServer()

    try:
        if type(pkg[0]) == type([]):
            #s.set_transport(2, 2)
            rpcServer.doCall(s.registration.delete_packages,up2dateAuth.getSystemId(), pkg)
        else:
            rpcServer.doCall(s.registration.delete_packages,up2dateAuth.getSystemId(), [pkg])            
    except rpclib.Fault, f:
        raise up2dateErrors.CommunicationError(f.faultString)

def updatePackageProfile():
    log.log_me("Updating package profile")
    s = rpcServer.getServer()
    
    try:
        #s.set_transport(2, 2)
        rpcServer.doCall(s.registration.update_packages,
               up2dateAuth.getSystemId(),
               rpmUtils.getInstalledPackageList())
    except rpclib.Fault, f:
        if f.faultCode == 99:
            raise up2dateErrors.DelayError(f.faultString)
        else:
            raise up2dateErrors.CommunicationError(f.faultString)


avail_package_lst = []
# Fetch the raw package list. We weed it down and munge it
# more agressevily in the PackageList class, this function
# is just used in a couple places (like --showall) so it's
# seperated
def availablePackageList(msgCallback=None, progressCallback=None):
    global avail_package_lst
    # if this is non-zero, we've already fetched it
    if len(avail_package_lst):
        return avail_package_lst

    availPkgList = []

    try:
        log.log_me("availablePackageList from network")
    except:
        pass

    # FIXME: replace with a up2date.getChannels() equilvinet when
    #        I find out where it belongs
    channels = rhnChannel.getChannels()
    up2dateUtils.DPRINT("availablePackageList::channels: %s" % (channels,))
    if not channels:
        return None
    availPkgList = []


    new_channels = []
    for channel in channels:
	if channel[0] not in rhnChannel.channel_blacklist:
	    new_channels.append(channel)
    channels = new_channels
    
    for channel in channels:
        if msgCallback:
            msgCallback("Fetching package list for channel: %s" % channel[0] )
        # a channel maybe empty, with no version
        if not channel[1]:
            continue
        package_list,type = rpcServer.doCall(rpmSource.psc.listPackageSource.listPackages,
                           channel[0],
                           channel[1],
                           msgCallback = msgCallback,
                           progressCallback = progressCallback )


        availPkgList = availPkgList + package_list

    avail_package_lst = availPkgList
    return availPkgList

def obsoletesList(msgCallback=None, progressCallback=None):

    obsoletesList = []
    channels =  rhnChannel.getChannels()
    up2dateUtils.DPRINT("availablePackageList::channels: %s" % (channels,))
    if not channels:
        return None

    new_channels = []
    for channel in channels:
	if channel[0] not in rhnChannel.channel_blacklist:
	    new_channels.append(channel)
    channels = new_channels

    for channel in channels:
        # a channel maybe empty, with no version
        if not channel[1]:
            continue
        if msgCallback:
            # FIXME: plugin a useful message and dump it in up2dateMessages for reuse
            msgCallback("Fetching Obsoletes list for channel: %s" % channel[0])
        obsoletes_list,type = rpcServer.doCall(rpmSource.psc.getObsoletesSource.getObsoletes,
                                               channel[0],
                                               channel[1],
                                               msgCallback = msgCallback,
                                               progressCallback = progressCallback )
        

        obsoletesList = obsoletesList + obsoletes_list

    return obsoletesList
