#!/usr/bin/python

import rpcServer
import rpmSource
import rhnDefines
import config
import os
import xmlrpclib
import up2dateErrors
import rpmUtils
import up2dateUtils
import string
import time

import up2dateLog
log = up2dateLog.initLog()


#grab an instance of the config class shared
cfg = config.initUp2dateConfig()

DEBUG=0
def DPRINT(string):
    if DEBUG:
        print  string

loginInfo = None

global loginInfo

def getSystemId():
    path = cfg.readEntry("systemIdPath")
    if not os.access(path, os.R_OK):
        return None
    
    f = open(path, "r")
    ret = f.read()
        
    f.close()
    return ret

# if a user has upgraded to a newer release of Red Hat but still
# has a systemid from their older release, they need to get an updated
# systemid from the RHN servers.  This takes care of that.
def maybeUpdateVersion():
    try:
        idVer = xmlrpclib.loads(getSystemId())[0][0]['os_release']
    except:
        # they may not even have a system id yet.
        return 0

    systemVer = up2dateUtils.getVersion()
    
    if idVer != systemVer:
      s = rpcServer.getServer()
    
      try:
          newSystemId = rpcServer.doCall(s.registration.upgrade_version, getSystemId(), systemVer)
      except xmlrpclib.Fault, f:
          raise up2dateErrors.CommunicationError(f.faultString)

      path = cfg.readEntry("systemIdPath")
      dir = path[:string.rfind(path, "/")]
      if not os.access(dir, os.W_OK):
          try:
              os.mkdir(dir)
          except:
              return 0
      if not os.access(dir, os.W_OK):
          return 0

      if os.access(path, os.F_OK):
          # already have systemid file there; let's back it up
          savePath = path + ".save"
          try:
              os.rename(path, savePath)
          except:
              return 0

      f = open(path, "w")
      f.write(newSystemId)
      f.close()
      try:
          os.chmod(path, 0600)
      except:
          pass



def login():

    server = rpcServer.getServer()

    systemId = getSystemId()

    maybeUpdateVersion()
    log.log_me("logging into up2date server")

    loginInfo = rpcServer.doCall(server.up2date.login, systemId)
    
        
    log.log_me("successfully retrieved authentication token from up2date server")

    DPRINT("logininfo: %s" % loginInfo)
    return loginInfo

def updateLoginInfo():
    log.log_me("updating login info")
    global loginInfo
    loginInfo = login()

    rpmSource.psc.updateLoginInfo(loginInfo)
    
