#!/usr/bin/python

import time
import string
import config

log = None
cfg = config.initUp2dateConfig()


class Log:
    """attempt to log all interesting stuff, namely, anything that hits the network
       any error messages, package installs, etc"""
    def __init__(self):
        self.app = "up2date"
        if cfg.readEntry("logFile"):
            self.log_file_name = cfg.readEntry("logFile")
        else:
            self.log_file_name = "/var/log/up2date"

   
        self.log_me("new up2date run started");
        

    def log_me(self, *args):
        self.log_info = "[%s] %s" % (time.ctime(time.time()), self.app)
	s = ""
        for i in args:
            s = s + "%s" % i
        self.write_log(s)

    def trace_me(self):
        import traceback
        x = traceback.extract_stack()
        bar = string.join(traceback.format_list(x))
        self.write_log(bar)

    def write_log(self, s):
        self.log_file = open(self.log_file_name, 'a')
        msg = "%s %s\n" % (self.log_info, str(s))
        self.log_file.write(msg)
        self.log_file.flush()
        self.log_file.close()


def initLog():
    global log
    if log == None:
        log = Log()
            
    return log
        
